# This file is a template, and might need editing before it works on your project.
# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages
#
# You can copy and paste this template into a new `.gitlab-ci.yml` file.
# You should not add this template to an existing `.gitlab-ci.yml` file by using the `include:` keyword.
#
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

deploy_dev:
  image: docker:latest
  services:
  - docker:dind
  stage: deploy
  only:
    refs:
      - dev
    variables:
      - $CI_COMMIT_BRANCH == "dev"
      - $CI_PIPELINE_SOURCE == "merge_request_event"
      - $CI_MERGE_REQUEST_STATE == "merged"
      - $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "dev"
      - $CI_MERGE_REQUEST_TARGET_PROJECT_PATH == "namepspace/projectns"
  before_script:
    - apt-get update
    - apt-get install -y rsync
    - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client git -y )'
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - ssh-keyscan 0.0.0.0 >> ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts  - eval $(ssh-agent -s)
    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
 
  script:
    - echo "Dev "
    - set -x 
    - echo "pre-production"
    - apk add --no-cache rsync
    - apk add --no-cache git
    - ssh deploy@0.0.0.0  "cd /path/to/projectindev && sudo chown -R deploy.deploy . "
    - rsync -avrz --exclude-from=filetoexcludeundesiredpaths * deploy@0.0.0.0:/path/to/projectindev
    - docker login registry.gitlab.com -u gitlabusername -p  token 
    - docker build -t registry.gitlab.com/namespace/projectns:dev-v1.0.0 .
    - docker push registry.gitlab.com/namespace/projectns:productv1.0.0
    - ssh deploy@0.0.0.0  "cd cd /path/to/projectindev && docker compose pull  "
    - ssh deploy@0.0.0.0  "cd cd /path/to/projectindev && docker compose up -d "
    - ssh deploy@0.0.0.0  "docker exec  dockernamedev /usr/bin/chown -R www-data:www-data /app "
deploy_test:
  image: docker:latest
  services:
  - docker:dind
  only:
    refs:
      - test
    variables:
      - $CI_COMMIT_BRANCH == "test"
      - $CI_PIPELINE_SOURCE == "merge_request_event"
      - $CI_MERGE_REQUEST_STATE == "merged"
      - $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "test"
      - $CI_MERGE_REQUEST_TARGET_PROJECT_PATH == "namespace/projectns"
  before_script:
    
     - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client git -y )'
     - eval $(ssh-agent -s)
     - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
     - mkdir -p ~/.ssh
     - chmod 700 ~/.ssh
     - ssh-keyscan 0.0.0.0 >> ~/.ssh/known_hosts
     - chmod 644 ~/.ssh/known_hosts    
    # Test Docker installation
     - docker --version
  script:
    - set -x 
    - echo "test"
    - apk add --no-cache rsync
    - apk add --no-cache git
    - ssh deploy@0.0.0.0  "cd /path/to/testproject && sudo chown -R deploy.deploy . "
    - rsync -avrz --exclude-from=fileofpathestoexclude * deploy@0.0.0.0:/path/to/testproject
    - docker login registry.gitlab.com -u gitlabusername -p  token 
    - docker build -t registry.gitlab.com/solinthr/dealer-portal:test .
    - docker push registry.gitlab.com/solinthr/dealer-portal:test
    - ssh deploy@0.0.0.0  "cd /path/to/projecttestpath && docker compose pull  "
    - ssh deploy@0.0.0.0  "cd /path/to/projecttestpath && docker compose up -d "
    - ssh deploy@0.0.0.0  "docker exec  dockertestname /usr/bin/chown -R www-data:www-data /app "

deploy_pre_prod:
  image: docker:latest
  stage: deploy
  services:
  - docker:dind
  only:
    refs:
      - pre-production
    variables:
      - $CI_COMMIT_BRANCH == "pre-production"
      - $CI_PIPELINE_SOURCE == "merge_request_event"
      - $CI_MERGE_REQUEST_STATE == "merged"
      - $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "pre-production"
      - $CI_MERGE_REQUEST_TARGET_PROJECT_PATH == "namespace/projectns"
  before_script:
    - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client git -y )'
    - eval $(ssh-agent -s)
    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - ssh-keyscan 0.0.0.0  >> ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts
  script:
    - set -x 
    - echo "pre-production"
    - apk add --no-cache rsync
    - apk add --no-cache git
    - ssh deploy@0.0.0.0  "cd /path/to/projectinprod && sudo chown -R deploy.deploy . "
    - rsync -avrz --exclude-from=filetoexcludeundesiredpaths * deploy@0.0.0.0:/path/to/projectinprod
    - docker login registry.gitlab.com -u gitlabusername -p  token 
    - docker build -t registry.gitlab.com/namespace/projectns:preprod-v1.0.0 .
    - docker push registry.gitlab.com/namespace/projectns:preprodv1.0.0
    - ssh deploy@0.0.0.0  "cd cd /path/to/projectinpreprod && docker compose pull  "
    - ssh deploy@0.0.0.0  "cd cd /path/to/projectinpreprod && docker compose up -d "
    - ssh deploy@0.0.0.0  "docker exec  dockernamepreprod /usr/bin/chown -R www-data:www-data /app "
deploy_prod:
  image: docker:latest
  stage: deploy
  services:
  - docker:dind
  only:
    refs:
      - master
    variables:
      - $CI_COMMIT_BRANCH == "master"
      - $CI_PIPELINE_SOURCE == "merge_request_event"
      - $CI_MERGE_REQUEST_STATE == "merged"
      - $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "master"
      - $CI_MERGE_REQUEST_TARGET_PROJECT_PATH == "namespace/projectns"
  before_script:
     - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client git -y )'
     - eval $(ssh-agent -s)
     - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
     - mkdir -p ~/.ssh
     - chmod 700 ~/.ssh
     - ssh-keyscan 0.0.0.0  >> ~/.ssh/known_hosts
     - chmod 644 ~/.ssh/known_hosts  
  script:
   - set -x 
    - echo "production"
    - apk add --no-cache rsync
    - apk add --no-cache git
    - ssh deploy@0.0.0.0  "cd /path/to/projectinprod && sudo chown -R deploy.deploy . "
    - rsync -avrz --exclude-from=file * deploy@0.0.0.0:/path/to/projectinprod
    - docker login registry.gitlab.com -u gitlabusername -p  token 
    - docker build -t registry.gitlab.com/namespace/projectns:prod-v1.0.0 .
    - docker push registry.gitlab.com/namespace/projectns:productv1.0.0
    - ssh deploy@0.0.0.0  "cd cd /path/to/projectinprod && docker compose pull  "
    - ssh deploy@0.0.0.0  "cd cd /path/to/projectinprod && docker compose up -d "
    - ssh deploy@0.0.0.0  "docker exec  dockernameprod /usr/bin/chown -R www-data:www-data /app "
